package com.sun.jmx.snmp.IPAcl;

import java.net.UnknownHostException;
import java.net.InetAddress;
import java.io.Serializable;
import java.security.Principal;

class PrincipalImpl implements Principal, Serializable
{
    private static final long serialVersionUID = -7910027842878976761L;
    private InetAddress[] add;
    
    public PrincipalImpl() throws UnknownHostException {
        this.add = null;
        (this.add = new InetAddress[1])[0] = InetAddress.getLocalHost();
    }
    
    public PrincipalImpl(String s) throws UnknownHostException {
        this.add = null;
        if (s.equals("localhost") || s.equals("127.0.0.1")) {
            (this.add = new InetAddress[1])[0] = InetAddress.getByName(s);
        }
        else {
            this.add = InetAddress.getAllByName(s);
        }
    }
    
    public PrincipalImpl(InetAddress inetAddress) {
        this.add = null;
        (this.add = new InetAddress[1])[0] = inetAddress;
    }
    
    @Override
    public String getName() {
        return this.add[0].toString();
    }
    
    @Override
    public boolean equals(Object o) {
        if ((o instanceof PrincipalImpl)) {
            int i = 0;
            while (i < this.add.length) {
                if (this.add[i].equals(((PrincipalImpl)o).getAddress())) {
                    return true;
                }
                ++i;
            }
            return false;
        }
        return false;
    }
    
    @Override
    public int hashCode() {
        return this.add[0].hashCode();
    }
    
    @Override
    public String toString() {
        return "PrincipalImpl :" + this.add[0].toString();
    }
    
    public InetAddress getAddress() {
        return this.add[0];
    }
    
    public InetAddress[] getAddresses() {
        return this.add;
    }
}
